﻿using System.Data;
using System.Windows.Forms;

namespace TrueDBGrid_EditCell
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            var dataSet = new DataSet();
            dataSet.ReadXml("Cars.xml");

            c1TrueDBGrid1.DataSource = dataSet;
            c1TrueDBGrid1.DataMember = "Cars";

            //direction after pressing enter key
            c1TrueDBGrid1.DirectionAfterEnter = C1.Win.C1TrueDBGrid.DirectionAfterEnterEnum.MoveRight;

            c1TrueDBGrid1.KeyPress += C1TrueDBGrid1_KeyPress;
            c1TrueDBGrid1.RowColChange += C1TrueDBGrid1_RowColChange;
        }

        bool _isEntered;

        private void C1TrueDBGrid1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if((Keys)e.KeyChar == Keys.Enter)
            {
                _isEntered = true;
            }
        }

        private void C1TrueDBGrid1_RowColChange(object sender, C1.Win.C1TrueDBGrid.RowColChangeEventArgs e)
        {
            if(_isEntered)
            {
                _isEntered = false;
                c1TrueDBGrid1.EditActive = true;
                var editor = c1TrueDBGrid1.Editor as TextBox;
                editor.SelectionLength = 0;
                editor.SelectionStart = editor.TextLength;
            }
        }
    }
}
